<?php

	/*
	Media attachment framework
	@categories for media attachments
	*/
	
	function gridfx_fix_category_count() {
		global $wp_taxonomies;
		if ( taxonomy_exists('category') ) $wp_taxonomies['category']->update_count_callback = '_update_generic_term_count';
		if ( taxonomy_exists('post_tag') ) $wp_taxonomies['post_tag']->update_count_callback = '_update_generic_term_count';
	}
	add_action( 'init', 'gridfx_fix_category_count' );
	
	function gridfx_add_categories_to_attachments() {
		register_taxonomy_for_object_type( 'category', 'attachment' );
	}
	add_action( 'init' , 'gridfx_add_categories_to_attachments' );
	
	function gridfx_add_tags_to_attachments() {
		register_taxonomy_for_object_type( 'post_tag', 'attachment' );
	}
	add_action( 'init' , 'gridfx_add_tags_to_attachments' );
	
	/* custom taxonomy for attachments */
	function gridfx_add_media_taxonomy() {
		$labels = array(
			'name'              => __('Media Categories','gridfx'),
			'singular_name'     => __('Media Category','gridfx'),
			'search_items'      => __('Search Media Categories','gridfx'),
			'all_items'         => __('All Media Categories','gridfx'),
			'parent_item'       => __('Parent Media Category','gridfx'),
			'parent_item_colon' => __('Parent Media Category:','gridfx'),
			'edit_item'         => __('Edit Media Category','gridfx'),
			'update_item'       => __('Update Media Category','gridfx'),
			'add_new_item'      => __('Add New Media Category','gridfx'),
			'new_item_name'     => __('New Media Category Name','gridfx'),
			'menu_name'         => __('Media Categories','gridfx')
		);
	 
		$args = array(
			'labels' => $labels,
			'hierarchical' => true,
			'query_var' => 'true',
			'rewrite' => 'true',
			'show_admin_column' => 'true',
			'update_count_callback' => '_update_generic_term_count'
		);
	 
		register_taxonomy( 'gfx_media', 'attachment', $args );
	}
	add_action( 'init', 'gridfx_add_media_taxonomy' );