<?php

	add_action('wp_head','gridfx_ajaxurl');
	function gridfx_ajaxurl() { ?>
		<script type="text/javascript">
		var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
		</script>
	<?php
	}
	
	/* Give a like */
	add_action('wp_ajax_nopriv_gridfx_like_item', 'gridfx_like_item');
	add_action('wp_ajax_gridfx_like_item', 'gridfx_like_item');
	function gridfx_like_item(){
		$post_id = $_POST['post_id'];
		
		if(!isset($_COOKIE['vote_status_'.$post_id])) {
			/* Get $_POST request */
			
			/* update likes count */
			$days = gridfx_get_option('voting_duration');
			setcookie('vote_status_'.$post_id ,1, time()+($days*24*60*60) , '/');
			$likes = (int)get_post_meta($post_id, 'gridfx_likes', true);
			update_post_meta($post_id, 'gridfx_likes', $likes+1);		
			$output['likes'] = number_format_i18n($likes+1);
			$output['vote'] = true;
			$output=json_encode($output);
			if(is_array($output)){ print_r($output); }else{ echo $output; } die;
		}else{
				
			$likes = (int)get_post_meta($post_id, 'gridfx_likes', true);
			$output['likes'] = number_format_i18n($likes);
			$output['vote'] = false;
			$output=json_encode($output);
			if(is_array($output)){ print_r($output); }else{ echo $output; } die;
		}
	}

	/* Get inline content for post */
	add_action('wp_ajax_nopriv_gridfx_get_content', 'gridfx_get_content');
	add_action('wp_ajax_gridfx_get_content', 'gridfx_get_content');
	function gridfx_get_content(){

		/* Get $_POST request */
		$post_id = $_POST['post_id'];
		
		/* update view count */
		$views = (int)get_post_meta($post_id, 'gridfx_views', true);
		update_post_meta($post_id, 'gridfx_views', $views+1);		
		$output['views'] = number_format_i18n($views+1);
		
		$output['res'] = gridfx_get_content_template($_POST);
		
		$output=json_encode($output);
		if(is_array($output)){ print_r($output); }else{ echo $output; } die;

	}
	
	/* Get more posts */
	add_action('wp_ajax_nopriv_gridfx_load_posts', 'gridfx_load_posts');
	add_action('wp_ajax_gridfx_load_posts', 'gridfx_load_posts');
	function gridfx_load_posts(){

		/* Get $_POST request */
		
		
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($_POST[$key])) {
				$$key = $_POST[$key];
			}else {
				$$key = '';
			}
		}
		
		$args = $_POST;

		ob_start();
		
		$query = new WP_Query( gridfx_items_query( $args ) );
		if ($query->have_posts()) :
			while ($query->have_posts()) : $query->the_post();
				if (gridfx_featured_image_uri( $args )) { 
					include gridfx_path . 'templates/loop-single.php';
				}
			endwhile;
		else :
			$output['error'] = '<div class="gridfx-noresults">'. __('No more! Clear your search or try another word.','gridfx') . '</div>';
		endif;
		
		$output['response'] = ob_get_contents();
		ob_end_clean();
		
		$output=json_encode($output);
		if(is_array($output)){ print_r($output); }else{ echo $output; } die;

	}
	
	
	function get_default_args() {
		return array(					
				                'action' => 'gridfx_load_posts' ,
								'paged' => '2',
								'title' => '0',
								'users_dropdown'=>'1',
								'description' => '0',
								'theme' => 'light',
								'default_theme' => 'light',
								'transparent' => '0',
								'primary_font' => 'Open Sans',
								'custom_css' => '0',
								'margin' => '30',
								'crop' => '0',
								'crop_quickmode' => '0',
								'crop_width' => '500',
								'crop_height' => '281',
								'crop_pos' => 't',
								'columns' => '3',
								'items_container_width' => '100',
								'image_max_width' => '100',
								'item_content_width' => '70',
								'item_content_left_width' => '50',
								'item_content_right_width' => '45',
								'instantsearch' => '1',
								'search_placeholder' => 'Search',
								'integrate' => '0',
								'posttypes' => 'post',
								'sortmenu' => '1',
								'taxonomy_filter' => 'category',
				                'hide_empty_cat' => '1',
            				    'cat_list_orderby' => 'name',
        				        'posts_per_page' => '9',
				                'orderby' => 'date',
            				    'order' => 'DESC',
            				    'include_terms_tree' => '0',
				                'include_terms' => '0',
        				        'exclude_terms_tree' => '0',
				                'exclude_terms' => '0',
                				'post_parent' => '0',
                				'load_more' => 'button',
				                'load_more_text' => 'Load more',
                				'loaded_all_text' => 'Loaded all content',
          					    'load_more_img' => 'http://localhost/wordpress/gridfx/wp-content/plugins/gridfx/images/loading-more.png',
				                'enable_grid_media' => '1',
				                'global_image_action' => '0',
				                'link_to_post' => '0',
				                'link_to_post_text' => 'full post',
				                'show_title' => '1',
				                'pre_title' => '0',
				                'excerpt_below_title' => '0',
				                'excerpt_over_image' => '0',
				                'tags_filter' => 'post_tag',
				                'item_custom_field' => '0',
				                'item_custom_field_filter' => '0',
				                'show_views' => '1',
				                'show_likes' => '1',
				                'show_comments' => '0',
				                'show_corner' => '0',
								'single_show_corner' => '0' ,
				                'show_corner_key' => '0',
				                'show_overlay_title_v2' => '0',
				                'show_overlay_title' => '0',
				                'show_overlay_title_class' => 'top',
				                'overlay_title_css' => '0',
				                'shadow_layer' => 'hide',
				                'transparent_layer' => 'hide',
				                'overlay_lightbox_text' => '1',
				                'photos_label' => 'photos',
				                'photos_label_singular' => 'photo',
				                'more_details_text' => 'quick view',
				                'item_links' => '0',
				                'item_extended_links' => '0',
				                'single_theme' => 'dark',
				                'default_single_theme' => 'dark',
				                'scrollbar_theme' => 'light-thick',
				                'single_show_content' => '1',
				                'single_hide_image' => '0',
				                'single_show_views' => '1',
				                'single_show_likes' => '1',
				                'single_show_comments' => '0',
				                'single_show_corner] => 0',
                				'single_show_corner_key' => '0',
				                'single_item_links' => '0',
            				    'single_item_custom_field' => '0',
                				'single_image_action' => 'fancybox',
				                'grid_image_size' => 'large',
                				'single_image_size' => 'large',
                				'placeholder' => '1',
				                'builtin_placeholder' => 'light',
                				'custom_placeholder' => '0',
				                'loader_mini' => 'http://localhost/wordpress/gridfx/wp-content/plugins/gridfx/images/loader_mini.gif',
				                'lightbox_background' => '0',
				                'lightbox_padding' => '0',
				                'lightbox_margin' => '0',
				                'lightbox_title' => '0',
				                'lightbox_title_type' => 'float',
				                'lightbox_closeclick' => '1',
				                'lightbox_closebtn' => '0',
				                'lightbox_buttons' => '0',
				                'lightbox_thumbs' => '1',
				                'taxonomy_filter_woo' => 'product_cat,product_tag',
				                'voting_duration' => '8',
				                'add_to_cart_choose' => '1',
				                'i' => '1'
		);
	}
