<?php

	/* Add post thumbnail support */
	add_theme_support('post-thumbnails');

	/* Registers and display the shortcode */
	add_shortcode('gridfx', 'gridfx' );
	function gridfx( $args=array() ) {
	
		global $gridfx_admin;
		wp_enqueue_script('jquery-effects-core');
		wp_enqueue_script('jquery-effects-scale');
		
		wp_register_style('gridfx_style', gridfx_url .'css/gridfx.css');
		wp_enqueue_style('gridfx_style');
		
		wp_register_style('gridfx_buttons', gridfx_url .'css/gridfx-buttons.css');
		wp_enqueue_style('gridfx_buttons');
		
		wp_register_style( 'gridfx_fontawesome', gridfx_url .'css/font-awesome.min.css');
		wp_enqueue_style('gridfx_fontawesome');
		
		wp_register_style('gridfx_fonts','http://fonts.googleapis.com/css?family=Oswald|Open+Sans:300italic,400italic,600italic,700italic,400,300,600,700');
		wp_enqueue_style('gridfx_fonts');

	
		
		if (isset($args['layout_modes']) && $args['layout_modes'] =='packery')
		{
			wp_register_script('gridfx_isotope_packeryA', gridfx_url .'scripts/isotope.pkgd.js', array(
			'jquery', 
			'jquery-ui-core', 
			'jquery-effects-slide'
		), null);
	
	
			wp_register_script('gridfx_isotope_packeryB', gridfx_url .'scripts/packery-mode.pkgd.min.js', array(
			'jquery', 
			'jquery-ui-core', 
			'jquery-effects-slide'
		), null);
		wp_enqueue_script('gridfx_isotope_packeryA');
		wp_enqueue_script('gridfx_isotope_packeryB');
		}

		else
		{
			
			
			wp_register_script('gridfx_isotope_masonry', gridfx_url .'scripts/jquery.isotope.min.js', array(
			'jquery', 
			'jquery-ui-core', 
			'jquery-effects-slide'
		), null);
		wp_enqueue_script('gridfx_isotope_masonry');
		

		}
	?>
		<script>

		   layoutmodes = "<?php if(isset($args['layout_modes'])) echo $args['layout_modes']?>";
		    
		
		
</script>
<?php
		wp_register_style( 'gridfx_scrollbar', gridfx_url .'css/jquery.mCustomScrollbar.css');
		wp_enqueue_style('gridfx_scrollbar');
		
		wp_register_script( 'gridfx_scrollbar', gridfx_url .'scripts/jquery.mCustomScrollbar.min.js', false, null);
		wp_enqueue_script('gridfx_scrollbar');
		
		wp_register_script( 'gridfx_fancybox', gridfx_url .'scripts/jquery.fancybox.pack.js', false, null);
		wp_enqueue_script('gridfx_fancybox');
		
		wp_register_script( 'gridfx_fancybox_buttons', gridfx_url .'scripts/jquery.fancybox-buttons.js', false, null);
		wp_enqueue_script('gridfx_fancybox_buttons');
		
		wp_register_script( 'gridfx_fancybox_media', gridfx_url .'scripts/jquery.fancybox-media.js', false, null);
		wp_enqueue_script('gridfx_fancybox_media');

		wp_register_script( 'gridfx_fancybox_thumbs', gridfx_url .'scripts/jquery.fancybox-thumbs.js', false, null);
		wp_enqueue_script('gridfx_fancybox_thumbs');
		
		wp_register_style( 'gridfx_fancybox', gridfx_url .'css/jquery.fancybox.css');
		wp_enqueue_style('gridfx_fancybox');
		
		wp_register_style( 'gridfx_fancybox_buttons', gridfx_url .'css/jquery.fancybox-buttons.css');
		wp_enqueue_style('gridfx_fancybox_buttons');

		wp_register_style( 'gridfx_fancybox_thumbs', gridfx_url .'css/jquery.fancybox-thumbs.css');
		wp_enqueue_style('gridfx_fancybox_thumbs');
		
		wp_register_script( 'gridfx_mousewheel', gridfx_url .'scripts/jquery.mousewheel.min.js', false, null);
		wp_enqueue_script('gridfx_mousewheel');
		
		wp_register_script( 'gridfx_ajax', gridfx_url .'scripts/ajax-functions.js', false, null);
		wp_enqueue_script('gridfx_ajax');
		
		wp_register_script( 'gridfx_chosen', gridfx_url .'scripts/chosen.jquery.min.js', false, null);
		wp_enqueue_script('gridfx_chosen');
		
		wp_register_style( 'gridfx_chosen', gridfx_url .'css/chosen.css');
		wp_enqueue_style('gridfx_chosen');
		
		wp_register_script( 'gridfx_script', gridfx_url .'scripts/custom.js', false, null);
		wp_enqueue_script('gridfx_script');
	
		STATIC $i = 0;

		// args
		$gridfx_opts =  get_option('gridfx');
		foreach( $gridfx_opts as $option => $value) {
			$defaults[$option] = gridfx_get_option_string($option, $gridfx_opts);
		}
		$args = wp_parse_args( $args, $defaults );

		ob_start();
		if($args['transparent_layer']=='show')
		{
			wp_register_script( 'gridfx_transparent', gridfx_url .'scripts/transparent.js', false, null);
			wp_enqueue_script('gridfx_transparent');
		}
	
		/* increment wall */
		$i++;
		$args['i'] = $i;
		
		if (isset($args['index'])) {
			$args['i'] = $args['index'];
		}
		
		/* pre-query, template, integration */
		if ($args['integrate']) {
			$args = gridfx_setup_integration( $args['integrate'], $args );
		}
		
		/* pre-filtering */
		if ($args['link_to_post']) {
			if($args['link_to_post']==1) {
				if (!$args['item_extended_links']) {
					$args['item_extended_links'] = 'post|'.__('Read full post','gridfx');
				} else {
					$args['item_extended_links'] = 'post|'.__('Read full post','gridfx').','.$args['item_extended_links'];
				}
			}
			if($args['link_to_post']==2) {
				if (!$args['item_links']) {
					$args['item_links'] = 'post|'.__('Read full post','gridfx');
				} else {
					$args['item_links'] = 'post|'.__('Read full post','gridfx').','.$args['item_links'];
				}
			}
		}
		
		/* Convert args to vars */
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($args[$key])) {
				$$key = $args[$key];
			}else {
				$$key = '';
			}
		}
		/* DONE */

		include gridfx_path . "templates/loop.php";
		if (!isset($wall_only)) {
			if (file_exists( gridfx_path . "templates/themes/$theme.php" )) {
				include gridfx_path . "templates/themes/$theme.php";
			} else {
				include gridfx_path . "templates/themes/$default_theme.php";
			}
			if (file_exists( gridfx_path . "templates/themes/single/$single_theme.php" )) {
				include gridfx_path . "templates/themes/single/$single_theme.php";
			} else {
				include gridfx_path . "templates/themes/single/$default_single_theme.php";
			}
			include gridfx_path . "templates/css.php";
		}
		$output = ob_get_contents();
		ob_end_clean();
		wp_reset_query();
		return $output;
	}
	
	/* outputs a nice taxonomy word on nav */
	function gridfx_nice_dropdown_all($taxonomy) {
		switch($taxonomy){
			default:
				$the_tax = get_taxonomy( $taxonomy );
				$title = $the_tax->labels->name;
				echo sprintf(__('All %s','gridfx'), $title);
				break;
		}
	}
	
	/* gets post excerpt based on word count */
	function gridfx_excerpt($excerpt_length) {
		global $post;
		$text = null;
		if ( '' == $text ) {
			$text = wp_filter_nohtml_kses(  get_the_content() );
			$text = preg_replace('/\b(https?|ftp|file):\/\/[-A-Z0-9+&@#\/%?=~_|$!:,.;]*[A-Z0-9+&@#\/%=~_|$]/i', '', $text);
			$words = explode(' ', $text, $excerpt_length + 1);
			if (count($words)> $excerpt_length) {
				array_pop($words);
				array_push($words, '...');
                $text = implode(' ', $words);
			}
		}
		if ($text) {
			echo '<div class="gridfx-excerpt">'.stripslashes( $text ).'</div>';
		}
	}
	
	/* returns true if post has media */
	function gridfx_is_media($enable_grid_media=1){
		global $post;
		if ($enable_grid_media) {
			$regex = preg_match("/((http|https|ftp|ftps)[:=#\w\.\/\?\-]+)/",$post->post_content, $matches);
			if (isset($matches[0])){
				$url = $matches[0];
			} else {
				$url = null;
			}
			if (strpos($url, 'vimeo.com') > 0 || strpos($url, 'youtube.com') > 0 || strpos($url, 'dailymotion.com') > 0) {
				return true;
			}
			if (strpos($url, 'soundcloud.com') > 0){
				return true;
			}
		}
		return false;
	}
	
	/* Shows a media URL */
	function gridfx_media(){
		global $post;
		$res = null;
		$regex = preg_match("/((http|https|ftp|ftps)[:=#\w\.\/\?\-]+)/",$post->post_content, $matches);
		$url = $matches[0];
		
		/* soundcloud */
		if (strpos($url, 'soundcloud.com') > 0 ) {
			$soundcloud = '<iframe width="100%" height="166" scrolling="no" frameborder="no" src="http://w.soundcloud.com/player/?url='.$url.'&auto_play=false"></iframe>';
			$res .= $soundcloud;
		}
		
		/* vimeo */
		if (strpos($url, 'vimeo.com') > 0) {
			$id = (int) substr(parse_url($url, PHP_URL_PATH), 1);
			$res = "<div class='gridfx-media'>";
			$res .= "<iframe src='//player.vimeo.com/video/$id?title=0&amp;byline=0&amp;portrait=0' frameborder='0' webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>";
			$res .= "</div>";
		}

		
		/* youtube */
		if (strpos($url, 'youtube.com') > 0) {
			preg_match('/(?<=v=)[^&]+/', $url, $id);
			if(isset($id[0]))//Added By Rajashri Samal on 4th Sep 2014
			$id = $id[0];
			$res = "<div class='gridfx-media'>";
			$res .= "<iframe src='//www.youtube.com/embed/$id' frameborder='0' allowfullscreen></iframe>";
			$res .= "</div>";
		}
		
		/* dailymotion */
		if (strpos($url, 'dailymotion.com') > 0) {
			$id = strtok(basename($url), '_');
			$res = "<div class='gridfx-media'>";
			$res .= "<iframe src='http://www.dailymotion.com/embed/video/$id' frameborder='0'></iframe>";
			$res .= "</div>";
		}

		echo $res;
	}
	
	/* Sets up integration */
	function gridfx_setup_integration( $integrate, $args ) {
		switch( $integrate ) {
			
			case 'woocommerce';
				$args['posttypes'] = 'product';
				$args['taxonomy_filter'] = $args['taxonomy_filter_woo'];
				$args['tags_filter'] = 'product_tag';
				$args['item_custom_field'] = 'woocommerce';
				$args['item_extended_links'] = 'woocommerce';
				$args['single_item_links'] = 'woocommerce';
				$args['single_item_custom_field'] = 'woocommerce';
				break;
				
		}
		return $args;
	}
	
	/* Display item_custom_field argument */
	function gridfx_item_custom_field($field, $filter=0) {
		global $post;
		$meta_value = get_post_meta(get_the_ID(), $field, true);
		switch($field) {
			default:
				if ($filter == 'euro' && (double)$meta_value) $meta_value = number_format ($meta_value,2,",",".").'€';
				if ($filter == 'dollar' && (double)$meta_value) $meta_value = number_format( $meta_value,2,".",",").'$';
				if ($filter == 'plain' && (double)$meta_value) $meta_value = number_format( $meta_value,2,".",",");
				return $meta_value;
				break;
			case 'woocommerce':
				$product = gridfx_woo( get_the_ID() );
				$price = $product->get_price_html();
				return $price;
				break;
		}
	}
	
	/* Get WooCommerce product */
	function gridfx_woo( $product_id, $args = array() ) {
	  $product = null;
	  if ( version_compare( WOOCOMMERCE_VERSION, "2.0.0" ) >= 0 ) {
		// WC 2.0
		$product = get_product( $product_id, $args );
	  } else {
		
		// old style, get the product or product variation object
		if ( isset( $args['parent_id'] ) && $args['parent_id'] ) {
		  $product = new WC_Product_Variation( $product_id, $args['parent_id'] );
		} else {
		  // get the regular product, but if it has a parent, return the product variation object
		  $product = new WC_Product( $product_id );
		  if ( $product->get_parent() ) {
			$product = new WC_Product_Variation( $product->id, $product->get_parent() );
		  }
		}
	  }
	  return $product;
	}
	
	/* Convert all args to data */
	function gridfx_args_to_data( $args ) {
		$res = null;
		foreach($args as $k => $v) {
			if ( $v == '' || empty($v) ) {
				$v = (int)$v;
			} else {
				$v = htmlentities($v, ENT_QUOTES);
			}
			$res .= " data-$k='$v'";
		}
		echo $res;
	}
	
	/* Setup fancybox stuff */
	function gridfx_setup_fancybox_links( $args, $i ) {
		global $post;
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($args[$key])) {
				$$key = $args[$key];
			}else {
				$$key = '';
			}
		}
		/* fetch images */
		$arr = array(
				'post_type' => 'attachment',
				'numberposts' => -1,
				'post_mime_type' => 'image',
				'orderby' => 'menu_order',
				'order' => 'ASC'
		);
		
		$arr['include'] = $post->ID;
		$attachments = get_posts($arr);
		$count = 1;
		
		/* many images */
		if (has_post_thumbnail($post->ID)) {
			$featured_image = get_post_thumbnail_id($post->ID);
			$arr['exclude'] = $featured_image;
			$arr['post_parent'] = $post->ID;
			$arr['include'] = '';
			$attachments = get_posts($arr);
			$count = count($attachments)+1;
		}
				
		/* count and text */
		if ($count > 0) {
			if ($count == 1) : $photos_label_text = $count . ' ' . $photos_label_singular; else : $photos_label_text = $count . ' ' . $photos_label; endif;
			$icon = 'camera';
		} else {
			$icon = 'resize-full';
		}
		
		if ( $attachments || has_post_thumbnail($post->ID) ){ ?><?php if ($overlay_lightbox_text && !$show_overlay_title_v2) { ?><a href="#" data-group="group-<?php echo $i; ?>-<?php the_ID(); ?>" class="fancybox"><i class="grid-icon-<?php echo $icon; ?>"></i><span><?php echo $photos_label_text; ?></span></a><?php } ?>
		
			<?php if (has_post_thumbnail($post->ID)) {
				$attachment = get_post( get_post_thumbnail_id() );
				$url = wp_get_attachment_image_src($attachment->ID, 'full');
				$url = $url[0];
			?>
			<a href="#" data-fancybox-group="group-<?php echo $i; ?>-<?php the_ID(); ?>" class="fancybox" data-url="<?php echo $url; ?>" data-title="<?php echo $attachment->post_title; ?>" style="display:none"></a>
			<?php } ?>
						
			<?php
			if ($attachments) {
				foreach($attachments as $attachment) {
					$url = wp_get_attachment_image_src($attachment->ID, 'full');
					$url = $url[0];
				?>
				<a href="#" data-fancybox-group="group-<?php echo $i; ?>-<?php the_ID(); ?>" class="fancybox" data-url="<?php echo $url; ?>" data-title="<?php echo $attachment->post_title; ?>" style="display:none"></a>
				<?php
				}
			}
			
		}
	}
	
	/* Setup load more button */
	function gridfx_setup_loadmorebutton( $query, $load_more_text ) {
		$max_pages = $query->max_num_pages;
		if ($max_pages > 1) {
			?>
			<div class="gridfx-load-more" data-max-pages="<?php echo $max_pages; ?>"><span><?php echo $load_more_text; ?></span></div>
			<?php
		}
	}
	
	/* Setup nav arrows */
	function gridfx_setup_nav( $query ){
		$max_pages = $query->max_num_pages;
		if ($max_pages > 1) {
			?>
			<a href="#" class="gridfx-control right active" data-max-pages="<?php echo $max_pages; ?>"><i class="grid-icon-angle-right"></i></a>
			<a href="#" class="gridfx-control left disabled" data-max-pages="<?php echo $max_pages; ?>"><i class="grid-icon-angle-left"></i></a>
			<?php
		}
	}
	
	/* Setup pagination */
	function gridfx_setup_pagination( $query ) {
		$max_pages = $query->max_num_pages;
		$page = $query->query_vars['paged'];
		if ($max_pages > 1) {
			echo '<div class="gridfx-control-pagi">';

			for($i = 1; $i<=$max_pages; $i++) { ?><a href="#" class="page gradient" data-page="<?php echo $i; ?>"><?php echo $i; ?></a><?php }

			echo '</div>';
		}
	}
	
	/* Get filtered custom template */
	function gridfx_filtered_custom_template($string) {
		global $post;
		$res = '<div class="gridfx-buttons '.$string.'">';
		
		switch($string) {
			default:
				$links = explode(',', $string);
				if ($links) {
					foreach($links as $link) {
						
						$sublink = explode('|',$link);
						
						if (empty($sublink[2])) {
							
							$sublink[2] = 'dark';
						}
						
						if ($sublink[0] == 'post') {
						$res .= '<a href="'.get_permalink(get_the_ID()).'" class="gridfx-button radius '.$sublink[2].'">'.$sublink[1].'</a>';
						} elseif ( get_post_meta(get_the_ID(), $sublink[0], true)) {
						$res .= '<a href="'. get_post_meta(get_the_ID(), $sublink[0], true) . '" class="gridfx-button radius '.$sublink[2].'">'.$sublink[1].'</a>';
						} else {
						if(isset($sublink[1]) && isset($sublink[2]))
						$res .= '<a href="'.$sublink[0].'" class="gridfx-button radius '.$sublink[2].'">'.$sublink[1].'</a>';
						}
						
					}
				}
				break;
				
			case 'woocommerce':
				$value=gridfx_get_option('add_to_cart_choose');
				if($value)
				{
					$res .= '<a href="'.get_permalink($post->ID).'" class="gridfx-button radius button alt">'.__('Details','gridfx').'</a>';
					$res .='<button type="submit" data-quantity="1" data-product_id="'.$post->ID.'" class="gridfx-button radius button alt add_to_cart_button product_type_simple bigger">'.__('Add To Cart','gridfx').'</button>';
				}
				else
				{
				$res .= '<a href="'.get_permalink($post->ID).'" class="gridfx-button radius button alt">'.__('Buy Now','gridfx').'</a>';
				}
				break;
		}
		
		$res .= '</div>';
		return $res;
	}
	
	/* Get filtered custom template links */

	function gridfx_filtered_custom_template_links($string) {
		global $post;
		$res = '<div class="gridfx-item-more-links '.$string.'">';
		
		switch($string) {
			default:
				$links = explode(',', $string);
				if ($links) {
					foreach($links as $link) {
						
						$sublink = explode('|',$link);
						if (isset($sublink[2]) && !$sublink[2]) {
							$sublink[2] = 'white';
						}
						
						if ($sublink[0] == 'post') {
						if(isset($sublink[2]) && isset($sublink[1]))
						$res .= '<a href="'.get_permalink(get_the_ID()).'" class="gridfx-button small radius '.$sublink[2].'">'.$sublink[1].'</a>';
						} elseif ( get_post_meta(get_the_ID(), $sublink[0], true)) {
						$res .= '<a href="'. get_post_meta(get_the_ID(), $sublink[0], true) . '" class="gridfx-button small radius '.$sublink[2].'">'.$sublink[1].'</a>';
						} else {
							if(isset($sublink[1]) && isset($sublink[2]))
								$res .= '<a href="'.$sublink[0].'" class="gridfx-button small radius '.$sublink[2].'">'.$sublink[1].'</a>';
						}
						
					}
				}
				break;
				
			case 'woocommerce':
				$value=gridfx_get_option('add_to_cart_choose');
				if($value)
				{
					$res .= '<a href="'.get_permalink($post->ID).'" class="gridfx-button small radius button alt">'.__('Details','gridfx').'</a>';
					$res .='<button type="submit" data-quantity="1" data-product_id="'.$post->ID.'" class="gridfx-button small radius button alt add_to_cart_button product_type_simple">'.__('Add To Cart','gridfx').'</button>';
				}
				else
				{
				$res .= '<a href="'.get_permalink($post->ID).'" class="gridfx-button small radius button alt">'.__('Buy Now','gridfx').'</a>';
				}
				break;
		}
		
		$res .= '</div>';
		return $res;
	}
	
	/* Get content template */
	function gridfx_get_content_template($args) {
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($args[$key])) {
				$$key = $args[$key];
			}else {
				$$key = '';
			}
		}
		ob_start();
		include_once gridfx_path . "templates/single.php";
		$contents = ob_get_contents();
		ob_end_clean();
		return $contents;
	}
	
	/* Get category class */
	function gridfx_category_class( $taxonomy_filter ) {
		if ($taxonomy_filter) {
			global $post;
			$taxonomies = explode(',',$taxonomy_filter);
			foreach($taxonomies as $taxonomy) {
				$terms = wp_get_post_terms($post->ID, $taxonomy);
				if ($terms) {
					foreach($terms as $term) {
						echo $term->slug.' ';
					}
				}
			}
		}
	}
	
	/* Get term class */
	function gridfx_term_class( $tags_filter ) {
		if ($tags_filter) {
			global $post;
			$taxonomies = explode(',',$tags_filter);
			foreach($taxonomies as $taxonomy) {
				$terms = wp_get_post_terms($post->ID, $taxonomy);
				if ($terms) {
					foreach($terms as $term) {
						echo $term->slug.' ';
					}
				}
			}
		}
	}
	
	/* Display list of item terms */
	function gridfx_item_terms( $tags_filter ) {
		if ($tags_filter) {
			global $post;
			$taxonomies = explode(',',$tags_filter);
			foreach($taxonomies as $taxonomy) {
				$terms = wp_get_post_terms($post->ID, $taxonomy);
				if ($terms) {
					foreach($terms as $term) {
						$term_links[] = '<a href="#" data-taxonomy="'.$taxonomy.'" data-category="'.$term->slug.'">'.$term->name.'</a>';
					}
				}
			}
		}
		if (isset($term_links)) {
			echo '<div class="gridfx-item-more-tags">';
			foreach($term_links as $term_link) {
				echo $term_link;
			}
			echo '</div>';
		}
	}
	
	/* Get post types */
	function gridfx_get_post_types($post_types) {
		$types = explode(',', $post_types);
		return $types;
	}
	
	/* Get array of query for single item */
	function gridfx_item_query($args) {
		$query = null;
		$query = array( 'post_type' => gridfx_get_post_types($args['posttypes']), 'p' => $args['post_id'] );
		if (strstr( $args['posttypes'], 'attachment') ) {
			$query['post_mime_type'] = 'image';
			$query['post_status'] = array('publish', 'inherit');
		}
		
		if (isset($args['postids'])){
			$query['post_type'] = 'any';
			$query['post_status'] = array('publish', 'inherit');
			unset($query['post_mime_type']);
		}
			
		return $query;
	}
	
	/* Search by title */
	add_filter( 'posts_where', 'gridfx_posts_where', 10, 2 );
	function gridfx_posts_where( $where, &$wp_query )
	{
		global $wpdb;
		if ( $gridfx_title_search = $wp_query->get( 'gridfx_title_search' ) ) {
			$where .= ' AND ' . $wpdb->posts . '.post_title LIKE \'%' . esc_sql( like_escape( $gridfx_title_search ) ) . '%\'';
		} elseif ( $gridfx_content_search = $wp_query->get( 'gridfx_content_search' ) ) {
			$where .= ' AND ' . $wpdb->posts . '.post_content LIKE \'%' . esc_sql( like_escape( $gridfx_content_search ) ) . '%\'';
		}
		return $where;
	}

	/* Get array of query */
	function gridfx_items_query($args) {
		global $wpdb;
		$query = null;
		
		if (!$args['posts_per_page']) {
			$args['posts_per_page'] = '-1';
		}

		$query = array('posts_per_page' => $args['posts_per_page'], 'post_type' => gridfx_get_post_types($args['posttypes']) );
		
		$tax_query = array('relation' => 'OR');
		
		/* when post type is attachment */
		if (strstr( $args['posttypes'], 'attachment') ) {
			$query['post_mime_type'] = 'image';
			$query['post_status'] = array('publish', 'inherit');
			if ($args['post_parent']) {
				$query['post_parent'] = $args['post_parent'];
			}
		} elseif ($args['post_parent']) {
			$query['post_parent'] = $args['post_parent'];
		}
		
		/* load more content, or paging */
		if ($args['paged']) {
			$query['paged'] = $args['paged'];
		}
		
		/* include terms only */
		if ($args['include_terms']) {
			$includes = explode(',',$args['include_terms']);
			foreach($includes as $id) {
				$taxonomies=get_taxonomies( array('public' => true), 'names');
				foreach($taxonomies as $taxonomy) {
					$term = get_term_by('id', $id, $taxonomy);
					if (isset($term->slug)) //Added by Rajashri Samal on $th Sep 2014
					{
					if (term_exists($term->slug, $taxonomy)) {
						$tax_query[] = array(
							'taxonomy' => $taxonomy,
							'field'    => 'id',
							'terms'     => $id,
							'include_children' => false,
							'operator' => 'IN'
						);
					}
				}
			}
		}
		}
		
		/* exclude terms only */
		if ($args['exclude_terms']) {
			$excludes = explode(',',$args['exclude_terms']);
			foreach($excludes as $id) {
				$taxonomies=get_taxonomies( array('public' => true), 'names');
				foreach($taxonomies as $taxonomy) {
					$term = get_term_by('id', $id, $taxonomy);
					if (term_exists($term->slug, $taxonomy)) {
						$tax_query[] = array(
							'taxonomy' => $taxonomy,
							'field'    => 'id',
							'terms'     => $id,
							'include_children' => false,
							'operator' => 'NOT IN'
						);
					}
				}
			}
		}
		
		/* include terms with children */
		if ($args['include_terms_tree']) {
			$includes = explode(',',$args['include_terms_tree']);
			foreach($includes as $id) {
				$taxonomies=get_taxonomies( array('public' => true), 'names');
				foreach($taxonomies as $taxonomy) {
					$term = get_term_by('id', $id, $taxonomy);
					if (term_exists($term->slug, $taxonomy)) {
						$tax_query[] = array(
							'taxonomy' => $taxonomy,
							'field'    => 'id',
							'terms'     => $id,
							'include_children' => true,
							'operator' => 'IN'
						);
					}
				}
			}
		}
		
		/* exclude terms with children */
		if ($args['exclude_terms_tree']) {
			$excludes = explode(',',$args['exclude_terms_tree']);
			foreach($excludes as $id) {
				$taxonomies=get_taxonomies( array('public' => true), 'names');
				foreach($taxonomies as $taxonomy) {
					$term = get_term_by('id', $id, $taxonomy);
					if (term_exists($term->slug, $taxonomy)) {
						$tax_query[] = array(
							'taxonomy' => $taxonomy,
							'field'    => 'id',
							'terms'     => $id,
							'include_children' => true,
							'operator' => 'NOT IN'
						);
					}
				}
			}
		}
		
		/* if tax query exists */
		if (isset($tax_query)) {
			$query['tax_query'] = $tax_query;
		}
		
		/* post order */
		if ($args['orderby']) {
			$query['orderby'] = $args['orderby'];
		}
		if(isset($args['meta_key']))
		if($args['meta_key']) {
			$query['meta_key'] = $args['meta_key'];
		}
		/* sort type */
		if ($args['order']) {
			$query['order'] = $args['order'];
		}
		if(isset($args['sticky_on_top']))
		if($args['sticky_on_top']) {
			$query['orderby']  = array( 'meta_value' => 'DESC', $args['orderby'] => $args['order'] );
			$query['meta_key'] = 'gridfx_sticky_post';
		}
			
		/* post includes */
		if (isset($args['postids'])) {
			$query['post__in'] = explode(',',$args['postids']);
			$query['orderby'] = 'post__in';
			$query['post_type'] = 'any';
			$query['post_status'] = array('publish', 'inherit');
			unset($query['post_mime_type']);
		}
		
		/* search term */
		if (isset($args['searchterm'])) {
			$query['gridfx_title_search'] = $args['searchterm'];
			$custom_query = new WP_Query( $query );
			if ($custom_query->found_posts == 0) {
				unset($query['gridfx_title_search']);
				$query['gridfx_content_search'] = $args['searchterm'];
				$custom_query2 = new WP_Query( $query );
				if ($custom_query2->found_posts == 0) {
					unset($query['gridfx_title_search']);
					unset($query['gridfx_content_search']);
					$query['gridfx_title_search'] = 'xasdsadsadweeeeeeeeeeeeeeeeeeeeee';
				}
			}
			$args['posts_per_page'] = '-1';
		}
		
		return $query;
		
	}
	
	/* Get children to include */
	function gridfx_menu_cat_include( $var_simple, $var, $tax, $hide_empty_cat ) {
		$categoriesToInclude = array();
		if ($var_simple) {
			$categoriesToInclude = explode(',',$var_simple);
		}
		if ($var) {
			$includes = explode(',',$var);
			foreach($includes as $id) {
				$terms = get_terms( $tax, array('child_of' => $id, 'hide_empty' => $hide_empty_cat));
				if (!empty($terms)) {
					foreach ($terms as $term) {
						$categoriesToInclude[] = $term->term_id;
					}
				}
				//$categoriesToInclude[] = $id;
			}
		}
		return $categoriesToInclude;
	}
	
	/* Get item type */
	function gridfx_item_type() {
		global $post;
		if (wp_attachment_is_image( $post->ID ) ) {
			return 'image';
		} else {
			return 'post';
		}
	}
	
	/* Item class - content or image only */
	function gridfx_item_class( $args ) {
		
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($args[$key])) {
				$$key = $args[$key];
			}else {
				$$key = '';
			}
		}
		
		if (gridfx_has_content() && !gridfx_is_media($enable_grid_media) && $single_show_content == 1) {
			echo 'left';
		} else {
			echo 'full';
		}
	}
	
	/* Check if item has content */
	function gridfx_has_content() {
		global $post;
		if ($post->post_content) {
			return true;
		}
		return false;
	}
	
	/* Display item content */
	function gridfx_the_content() {
		global $post;
		if (wp_attachment_is_image( $post->ID ) ) {
			echo '<div class="gridfx-contentbody">'.wpautop($post->post_content).'</a>';
		} else {
			echo '<div class="gridfx-contentbody">';
			the_content();
			echo '</div>';
		}
	}
	
	function gridfx_first_img() {
	  global $post, $posts;
	  $first_img = '';
	  ob_start();
	  ob_end_clean();
	  $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
	  if(isset($matches[1][0]))// Added by Rajashri Samal on 4th Sep 2014
	  $first_img = $matches[1][0];

	  if(!empty($first_img)) {
	  return $first_img;
	  }
	}
	
	/* Get featured image */
	function gridfx_featured_image( $args ) {
		global $post;
		
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($args[$key])) {
				$$key = $args[$key];
			}else {
				$$key = '';
			}
		}
		
		if ($crop == 0) {
		
			if (has_post_thumbnail( $post->ID ) ) {
				$image = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), $grid_image_size );
				return '<img src="'.$image[0].'" alt="" />';
			} elseif (wp_get_attachment_url($post->ID)) {
				$image = wp_get_attachment_image_src( $post->ID, $grid_image_size );
				return '<img src="'.$image[0].'" alt="" />';
			} elseif ( gridfx_first_img() != '' ) {
				return '<img src="'.gridfx_first_img().'" alt="" />';
			} elseif ($placeholder == 1) {
				if ($custom_placeholder) {
				return '<img src="'.$custom_placeholder.'" alt="" />';
				} else {
				return '<img src="'.gridfx_url . 'images/placeholders/'.$builtin_placeholder.'.jpg" alt="" />';
				}
			} else {
				return false;
			}
		
		} else {

			if (has_post_thumbnail( $post->ID ) ) {
				$image = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), $grid_image_size );
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.$image[0].'" alt="" />';
			} elseif (wp_get_attachment_url($post->ID)) {
				$image = wp_get_attachment_image_src( $post->ID, $grid_image_size );
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.$image[0].'" alt="" />';
			} elseif ( gridfx_first_img() != '' ) {
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.gridfx_first_img().'" alt="" />';
			} elseif ($placeholder == 1) {
				if ($custom_placeholder) {
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.$custom_placeholder.'" alt="" />';
				} else {
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='. gridfx_url . 'images/placeholders/'.$builtin_placeholder.'.jpg" alt="" />';
				}
			} else {
				return false;
			}
		
		}
		
	}
	
	/* Get featured image */
	function gridfx_featured_image_quickview( $args ) {
		global $post;
		
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($args[$key])) {
				$$key = $args[$key];
			}else {
				$$key = '';
			}
		}
		
		if ($crop == 0 || $crop_quickmode == 0) {
		
			if (has_post_thumbnail( $post->ID ) ) {
				$image = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), $single_image_size );
				return '<img src="'.$image[0].'" alt="" />';
			} elseif (wp_get_attachment_url($post->ID)) {
				$image = wp_get_attachment_image_src( $post->ID, $single_image_size );
				return '<img src="'.$image[0].'" alt="" />';
			} elseif ( gridfx_first_img() != '' ) {
				return '<img src="'.gridfx_first_img().'" alt="" />';
			} elseif ($placeholder == 1) {
				if ($custom_placeholder) {
				return '<img src="'.$custom_placeholder.'" alt="" />';
				} else {
				return '<img src="'.gridfx_url . 'images/placeholders/'.$builtin_placeholder.'.jpg" alt="" />';
				}
			} else {
				return false;
			}
		
		} else {
		
			if (has_post_thumbnail( $post->ID ) ) {
				$image = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), $single_image_size );
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.$image[0].'" alt="" />';
			} elseif (wp_get_attachment_url($post->ID)) {
				$image = wp_get_attachment_image_src($post->ID, $single_image_size );
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.$image[0].'" alt="" />';
			} elseif ( gridfx_first_img() != '' ) {
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.gridfx_first_img().'" alt="" />';
			} elseif ($placeholder == 1) {
				if ($custom_placeholder) {
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='.$custom_placeholder.'" alt="" />';
				} else {
				return '<img src="'.gridfx_url . 'timthumb.php?w='.$crop_width.'&amp;h='.$crop_height.'&amp;a='.$crop_pos.'&amp;q=100&amp;src='. gridfx_url . 'images/placeholders/'.$builtin_placeholder.'.jpg" alt="" />';
				}
			} else {
				return false;
			}
		
		}
		
	}
	
	/* Get featured image url only */
	function gridfx_featured_image_uri( $args ) {
		global $post;
		
		$default_args = get_default_args();
		
		foreach ($default_args as $key => $val){
			if(isset($args[$key])) {
				$$key = $args[$key];
			}else {
				$$key = '';
			}
		}
		
		if (has_post_thumbnail( $post->ID ) ) {
			$image = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'full' );
			return $image[0];
		} elseif (wp_get_attachment_url($post->ID)) {
			return wp_get_attachment_url($post->ID);
		} elseif ( gridfx_first_img() != '' ) {
			return gridfx_first_img();
		} elseif ($placeholder == 1) {
			if ($custom_placeholder) {
			return $custom_placeholder;
			} else {
			return gridfx_url . 'images/placeholders/'.$builtin_placeholder.'.jpg';
			}
		} else {
			return false;
		}
	}
	
	/* Get views count */
	function gridfx_get_views() {
		global $post;
		return number_format_i18n( (int) get_post_meta($post->ID, 'gridfx_views', true) );
	}
	
	/* Get likes count */
	function gridfx_get_likes() {
		global $post;
		return number_format_i18n( (int) get_post_meta($post->ID, 'gridfx_likes', true) );
	}
