<?php
/*
Plugin Name: Grid FX
Plugin URI: http://codecanyon.net/user/DeluxeThemes/portfolio?ref=DeluxeThemes
Description: An awesome ajax grid and masonry plugin that showcase anything beautifully.
Version: 2.6
Author: Deluxe Themes
Author URI: http://codecanyon.net/user/DeluxeThemes/portfolio?ref=DeluxeThemes
*/

define('gridfx_url',plugin_dir_url(__FILE__ ));
define('gridfx_path',plugin_dir_path(__FILE__ ));

	/* init */
	function gridfx_init() {  
		load_plugin_textdomain('gridfx', false, dirname(plugin_basename(__FILE__)) . '/languages');
	}
	add_action('init', 'gridfx_init');
	add_action( 'save_post', 'add_gridfx_post_meta' );

	function add_gridfx_post_meta($post_id) {
		if(get_post_meta($post_id , 'gridfx_likes' , true) == '') {
			add_post_meta($post_id, 'gridfx_likes', '0');
		}
	}
	
	/* functions */
	foreach (glob(gridfx_path . 'functions/*.php') as $filename) { require_once $filename; }
	
	/* administration */
	foreach (glob(gridfx_path . 'admin/*.php') as $filename) { include $filename; }
	
	foreach (glob(gridfx_path . 'updates/*.php') as $filename) { include $filename; }
	
	/* plugin links */
	add_filter( 'plugin_action_links', 'gridfx_admin_plugin_action_links', 10, 2 );
	function gridfx_admin_plugin_action_links( $links, $file ) {
		if ( $file == plugin_basename(dirname(__FILE__) . '/index.php') ) {
			$link_a = '<a href="admin.php?page=gridfx&tab=settings">' . __('Settings','gridfx') . '</a>';
			$link_b = '<a href="admin.php?page=gridfx&tab=generate">' . __('Generate','gridfx') . '</a>';
			$link_c = '<a href="admin.php?page=gridfx&tab=docs">' . __('Docs','gridfx') . '</a>';
			array_unshift($links, $link_c);
			array_unshift($links, $link_b);
			array_unshift($links, $link_a);
		}
		return $links;
	}

	
	require_once(dirname(__FILE__)."/functions/class-gridfx-updater.php");
	$envato_code_display = get_option('gridfx-envato-code');
	if($envato_code_display != false && get_transient('gridfx_update_check_flag') != 'checked_update'){
		new gridfx_updater($envato_code_display, plugin_basename(__FILE__) );
		set_transient('gridfx_update_check_flag', 'checked_update' , 7*24*60*60);
	}
